﻿UsePNGImageEncoder()
Global Dim col.l(127)
Global Dim pal.a(16)
; LoadImage(0,"sam-coupe-1x.png")
; StartDrawing(ImageOutput(0))
; For i=0 To 127
;   col(i)=Point(127-i,0)
; Next i
; StopDrawing()
; 
; For i=0 To 127
;   Debug "Data.l $"+Hex(col(i),#PB_Long)+";"+Str(i)
; Next i
Enumeration
  #file_open
  #file_save
  #file_quit
  #view_x2
  #view_x1
EndEnumeration

Restore scp
For i=0 To 127
  Read.l col(i)
Next i
CreateImage(0,512,384)
Global *m=AllocateMemory(1)
Global fs.q=-1
Global zo=2
Global d$="";destination
Procedure draws()
  If *m And fs>=24617
    If StartDrawing(ImageOutput(0))
      For i=0 To 15
        If fs>=24576+16
          pal(i)=PeekA(*m+24576+i)
        Else
          pal(i)=i
        EndIf
      Next i
      For y=0 To 191
        For x=0 To 127
          a.a=PeekA(*m+x+y*128)
          Box(x*2*zo,y*zo,2,2,col(pal(a>>4)))
          Box(x*2*zo+zo,y*zo,zo,zo,col(pal(a&15)))
        Next x
      Next y
      StopDrawing()
      If StartDrawing(CanvasOutput(0))
        DrawImage(ImageID(0),0,0)
        StopDrawing()
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure loadfile(f$)
  fs=FileSize(f$)
  d$=""
  If fs>=24617
    *m=ReAllocateMemory(*m,fs)
    If *m
      If ReadFile(0,f$)
        ReadData(0,*m,fs)
        CloseFile(0)
        d$=f$
        draws()
      Else
        MessageRequester("File error!","unable to read")
        fs=-1
      EndIf
    Else
      MessageRequester("Memory error","It happens")
      fs=-1
    EndIf
  Else
    MessageRequester("File error!","wrong size")
    fs=-1
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 512, 384+20, "SC mode 4 viewer", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  If CreateMenu(0, WindowID(0))
    MenuTitle("File")
    MenuItem(#file_open, "Open..."   +Chr(9)+"Ctrl+O")
    MenuItem(#file_save, "Save.."   +Chr(9)+"Ctrl+S")
    MenuBar()
    MenuItem(#file_quit, "Quit"   +Chr(9)+"Esc")
    MenuTitle("View")
    MenuItem(#view_x1, "x1")
    MenuItem(#view_x2, "x2")
    SetMenuItemState(0,#view_x2,1)
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_O, #file_open)
    AddKeyboardShortcut(0, #PB_Shortcut_Control | #PB_Shortcut_S, #file_save)
    
    AddKeyboardShortcut(0, #PB_Shortcut_Escape, #file_quit)
  EndIf
  
  CanvasGadget(0, 0, 0, 512, 384)
  EnableGadgetDrop(0,#PB_Drop_Files,#PB_Drag_Copy)
  
  If CountProgramParameters()
    loadfile(ProgramParameter(0))
  EndIf
  ;;loadfile("SCREEN5_f13.ss4")
  ;ReadFile(0,"GIZMO_f16.ss4")
  ;ReadFile(0,"SCREEN6_f12.ss4")
  ;   ReadFile(0,"SCREEN5_f13.ss4")
  ;   FileSeek(0,24576)
  ;   For i=0 To 15
  ;     pal(i)=ReadAsciiCharacter(0)
  ;   Next i
  ;   FileSeek(0,0)
  ;   
  ;   If StartDrawing(CanvasOutput(0))
  ;     For y=0 To 191
  ;       For x=0 To 127
  ;         a.a=ReadAsciiCharacter(0)
  ;         Box(x*4,y*2,2,2,col(pal(a>>4)))
  ;         Box(x*4+2,y*2,2,2,col(pal(a&15)))
  ;       Next x
  ;     Next y
  ;     StopDrawing()
  ;   EndIf
  ;   CloseFile(0)
  
  ;local vars
  pattern=0
  sp$=GetCurrentDirectory()
  Repeat
    Event=WaitWindowEvent()
;     If GetAsyncKeyState_(#VK_ESCAPE)&32768
;       Break
;     EndIf
    
    Select event
      Case #PB_Event_GadgetDrop
        loadfile(EventDropFiles())
      Case #PB_Event_Menu
        Select EventMenu()
          Case #view_x1
            SetMenuItemState(0,#view_x1,1)
            SetMenuItemState(0,#view_x2,0)
            FreeImage(0)
            CreateImage(0,256,192)
            ResizeGadget(0,128,96,256,192)
            zo=1
            draws()
          Case #view_x2
            SetMenuItemState(0,#view_x1,0)
            SetMenuItemState(0,#view_x2,1)
            FreeImage(0)
            CreateImage(0,512,384)
            ResizeGadget(0,0,0,512,584)
            zo=2
            draws()
          Case #file_quit:Break
          Case #file_open
  Pattern$ = "mode 4 (*.ss4)|*.ss4|All files (*.*)|*.*"
  File$ = OpenFileRequester("Please choose file to load", sp$, Pattern$, Pattern)
  If File$
    pattern=SelectedFilePattern()
    sp$=GetPathPart(File$)
    loadfile(File$)
  EndIf
          Case #file_save
            If d$<>""
              If LCase(Right(d$,3))="ss4"
                ;Debug d$
                d$=Mid(d$,1,Len(d$)-4)
                ;Debug d$
              EndIf
              ;d$+".png"
              Pattern$ = "PNG (*.png)|*.png"
              File$ = SaveFileRequester("Please choose file to save", d$, Pattern$, 0)
              If File$
                If LCase(Right(d$,3))<>"png"
                  File$+".png"
                EndIf
                SaveImage(0,File$,#PB_ImagePlugin_PNG)
              EndIf
            EndIf
        EndSelect
    EndSelect
  Until Event = #PB_Event_CloseWindow
EndIf
If *m
  FreeMemory(*m)
EndIf

DataSection
  scp:
  Data.l $0;0
  Data.l $490000;1
  Data.l $49    ;2
  Data.l $490049;3
  Data.l $4900  ;4
  Data.l $494900;5
  Data.l $4949  ;6
  Data.l $494949;7
  Data.l $242424;8
  Data.l $6D2424;9
  Data.l $24246D;10
  Data.l $6D246D;11
  Data.l $246D24;12
  Data.l $6D6D24;13
  Data.l $246D6D;14
  Data.l $6D6D6D;15
  Data.l $920000;16
  Data.l $DB0000;17
  Data.l $920049;18
  Data.l $DB0049;19
  Data.l $924900;20
  Data.l $DB4900;21
  Data.l $924949;22
  Data.l $DB4949;23
  Data.l $B62424;24
  Data.l $FF2424;25
  Data.l $B6246D;26
  Data.l $FF246D;27
  Data.l $B66D24;28
  Data.l $FF6D24;29
  Data.l $B66D6D;30
  Data.l $FF6D6D;31
  Data.l $92    ;32
  Data.l $490092;33
  Data.l $DB    ;34
  Data.l $4900DB;35
  Data.l $4992  ;36
  Data.l $494992;37
  Data.l $49DB  ;38
  Data.l $4949DB;39
  Data.l $2424B6;40
  Data.l $6D24B6;41
  Data.l $2424FF;42
  Data.l $6D24FF;43
  Data.l $246DB6;44
  Data.l $6D6DB6;45
  Data.l $246DFF;46
  Data.l $6D6DFF;47
  Data.l $920092;48
  Data.l $DB0092;49
  Data.l $9200DB;50
  Data.l $DB00DB;51
  Data.l $924992;52
  Data.l $DB4992;53
  Data.l $9249DB;54
  Data.l $DB49DB;55
  Data.l $B624B6;56
  Data.l $FF24B6;57
  Data.l $B624FF;58
  Data.l $FF24FF;59
  Data.l $B66DB6;60
  Data.l $FF6DB6;61
  Data.l $B66DFF;62
  Data.l $FF6DFF;63
  Data.l $9200  ;64
  Data.l $499200;65
  Data.l $9249  ;66
  Data.l $499249;67
  Data.l $DB00  ;68
  Data.l $49DB00;69
  Data.l $DB49  ;70
  Data.l $49DB49;71
  Data.l $24B624;72
  Data.l $6DB624;73
  Data.l $24B66D;74
  Data.l $6DB66D;75
  Data.l $24FF24;76
  Data.l $6DFF24;77
  Data.l $24FF6D;78
  Data.l $6DFF6D;79
  Data.l $929200;80
  Data.l $DB9200;81
  Data.l $929249;82
  Data.l $DB9249;83
  Data.l $92DB00;84
  Data.l $DBDB00;85
  Data.l $92DB49;86
  Data.l $DBDB49;87
  Data.l $B6B624;88
  Data.l $FFB624;89
  Data.l $B6B66D;90
  Data.l $FFB66D;91
  Data.l $B6FF24;92
  Data.l $FFFF24;93
  Data.l $B6FF6D;94
  Data.l $FFFF6D;95
  Data.l $9292  ;96
  Data.l $499292;97
  Data.l $92DB  ;98
  Data.l $4992DB;99
  Data.l $DB92  ;100
  Data.l $49DB92;101
  Data.l $DBDB  ;102
  Data.l $49DBDB;103
  Data.l $24B6B6;104
  Data.l $6DB6B6;105
  Data.l $24B6FF;106
  Data.l $6DB6FF;107
  Data.l $24FFB6;108
  Data.l $6DFFB6;109
  Data.l $24FFFF;110
  Data.l $6DFFFF;111
  Data.l $929292;112
  Data.l $DB9292;113
  Data.l $9292DB;114
  Data.l $DB92DB;115
  Data.l $92DB92;116
  Data.l $DBDB92;117
  Data.l $92DBDB;118
  Data.l $DBDBDB;119
  Data.l $B6B6B6;120
  Data.l $FFB6B6;121
  Data.l $B6B6FF;122
  Data.l $FFB6FF;123
  Data.l $B6FFB6;124
  Data.l $FFFFB6;125
  Data.l $B6FFFF;126
  Data.l $FFFFFF;127

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 161
; FirstLine = 128
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = samc.ico
; Executable = scs4v.exe
; CommandLine = SCREEN5_f13.ss4